;% Copyright (c) 1990-1994 The MITRE Corporation
;% 
;% Authors: W. M. Farmer, J. D. Guttman, F. J. Thayer
;%   
;% The MITRE Corporation (MITRE) provides this software to you without
;% charge to use, copy, modify or enhance for any legitimate purpose
;% provided you reproduce MITRE's copyright notice in any copy or
;% derivative work of this software.
;% 
;% This software is the copyright work of MITRE.  No ownership or other
;% proprietary interest in this software is granted you other than what
;% is granted in this license.
;% 
;% Any modification or enhancement of this software must identify the
;% part of this software that was modified, by whom and when, and must
;% inherit this license including its warranty disclaimers.
;% 
;% MITRE IS PROVIDING THE PRODUCT "AS IS" AND MAKES NO WARRANTY, EXPRESS
;% OR IMPLIED, AS TO THE ACCURACY, CAPABILITY, EFFICIENCY OR FUNCTIONING
;% OF THIS SOFTWARE AND DOCUMENTATION.  IN NO EVENT WILL MITRE BE LIABLE
;% FOR ANY GENERAL, CONSEQUENTIAL, INDIRECT, INCIDENTAL, EXEMPLARY OR
;% SPECIAL DAMAGES, EVEN IF MITRE HAS BEEN ADVISED OF THE POSSIBILITY OF
;% SUCH DAMAGES.
;% 
;% You, at your expense, hereby indemnify and hold harmless MITRE, its
;% Board of Trustees, officers, agents and employees, from any and all
;% liability or damages to third parties, including attorneys' fees,
;% court costs, and other related costs and expenses, arising out of your
;% use of this software irrespective of the cause of said liability.
;% 
;% The export from the United States or the subsequent reexport of this
;% software is subject to compliance with United States export control
;% and munitions control restrictions.  You agree that in the event you
;% seek to export this software or any derivative work thereof, you
;% assume full responsibility for obtaining all necessary export licenses
;% and approvals and for assuring compliance with applicable reexport
;% restrictions.
;% 
;% 
;% COPYRIGHT NOTICE INSERTED: Mon Apr 11 11:42:27 EDT 1994


(herald scheme-parse)

(define (PARSE-SEXP-MATCHING-OPERATOR parser match)
  (let ((last '#f))
    (cond ((eq? match (next-token parser))
	   (input-next-token parser)
	   (build-sexp nil last))
	  (else
	   (iterate loop ((parse-tree-list `(,(parse-matching-binding parser '\,))))
	     (cond ((eq? match (next-token parser))
		    (input-next-token parser)
		    (build-sexp (reverse parse-tree-list) last))
		   (last (report-error parser "\" | \" in illegal context."))
		   (else
		    (let ((next (input-next-token parser)))
		      (if (eq? next '\|)
			  (set last '#t)
			  (or (eq? next '\,)
			      (report-error parser "~A in illegal context." next))))
		    (loop (cons (parse-matching-binding parser '\,) parse-tree-list)))))))))

(define (BUILD-SEXP a-list last)
  (cond ((null? a-list) 'sexp%nil)
	((null? (cdr a-list)) `(sexp%cons  ,(car a-list) sexp%nil))
	((null? (cddr a-list))
	 (if last
	     `(sexp%cons ,(car a-list) ,(cadr a-list))
	     `(sexp%cons ,(car a-list) (sexp%cons  ,(cadr a-list) sexp%nil))))
	(else `(sexp%cons ,(car a-list) ,(build-sexp (cdr a-list) last)))))
      


(define (PREFIX-METHOD-LFB parser op)
  (parse-sexp-matching-operator parser '\}))

(make-operator *parse* '\{ '() prefix-method-lfb '() 200)

(make-operator *parse* '\| '() '() '() 10)

(make-operator *parse* '\} '() delimiter-error right-match-error 5)

