;% Copyright (c) 1990-1994 The MITRE Corporation
;% 
;% Authors: W. M. Farmer, J. D. Guttman, F. J. Thayer
;%   
;% The MITRE Corporation (MITRE) provides this software to you without
;% charge to use, copy, modify or enhance for any legitimate purpose
;% provided you reproduce MITRE's copyright notice in any copy or
;% derivative work of this software.
;% 
;% This software is the copyright work of MITRE.  No ownership or other
;% proprietary interest in this software is granted you other than what
;% is granted in this license.
;% 
;% Any modification or enhancement of this software must identify the
;% part of this software that was modified, by whom and when, and must
;% inherit this license including its warranty disclaimers.
;% 
;% MITRE IS PROVIDING THE PRODUCT "AS IS" AND MAKES NO WARRANTY, EXPRESS
;% OR IMPLIED, AS TO THE ACCURACY, CAPABILITY, EFFICIENCY OR FUNCTIONING
;% OF THIS SOFTWARE AND DOCUMENTATION.  IN NO EVENT WILL MITRE BE LIABLE
;% FOR ANY GENERAL, CONSEQUENTIAL, INDIRECT, INCIDENTAL, EXEMPLARY OR
;% SPECIAL DAMAGES, EVEN IF MITRE HAS BEEN ADVISED OF THE POSSIBILITY OF
;% SUCH DAMAGES.
;% 
;% You, at your expense, hereby indemnify and hold harmless MITRE, its
;% Board of Trustees, officers, agents and employees, from any and all
;% liability or damages to third parties, including attorneys' fees,
;% court costs, and other related costs and expenses, arising out of your
;% use of this software irrespective of the cause of said liability.
;% 
;% The export from the United States or the subsequent reexport of this
;% software is subject to compliance with United States export control
;% and munitions control restrictions.  You agree that in the event you
;% seek to export this software or any derivative work thereof, you
;% assume full responsibility for obtaining all necessary export licenses
;% and approvals and for assuring compliance with applicable reexport
;% restrictions.
;% 
;% 
;% COPYRIGHT NOTICE INSERTED: Mon Apr 11 11:42:27 EDT 1994


(herald SCHEME-PRINT)


(define (PRESENT-SEXP formatter op args bp)
  (ignore bp)
  (iterate loop ((args args)(accum '()))
    (let ((1st (present-tree formatter (car args) 0))
	  (2nd (cadr args)))
      (if (and (list? 2nd)
	       (eq? (car 2nd) op))
	  (loop (cdr 2nd) (cons 1st accum))
	  (let ((accum `(,(present-tree formatter 2nd 0) ,1st  ,@accum)))

	    (if (eq? (car accum) 'sexp%nil)
		`(\{ ,(map-alternate-insert '\, identity (reverse (cdr accum))) \})
		(reverse `(\} ,(car accum) \|
			      ,@(map-alternate-insert '\, identity (cdr accum))
			      \{))))))))

(make-presentation-format *form* 'sexp%cons '() present-sexp 80)


(define (TEX-PRESENT-SEXP formatter op args bp)
  (ignore bp)
  (iterate loop ((args args)(accum '()))
    (let ((1st (present-tree formatter (car args) 0))
	  (2nd (cadr args)))
      (if (and (list? 2nd)
	       (eq? (car 2nd) op))
	  (loop (cdr 2nd) (cons 1st accum))
	  (let ((accum `(,(present-tree formatter 2nd 0) ,1st  ,@accum)))

	    (if (eq? (car accum) 'sexp%nil)
		`( " \\{ " ,(map-alternate-insert '\, identity (reverse (cdr accum)))
			   " \\} " )
		(reverse `( " \\} " ,(car accum) \|
			      ,@(map-alternate-insert '\, identity (cdr accum))
			      " \\{ "))))))))


(define (TEX-PRESENT-EVAL formatter op args bp)
  (ignore bp)
  (let ((args (map (lambda (x) (present-tree formatter x 0)) args)))
    `(,(presentation-format formatter op)
      " [ "

      "\\!"

      " [ "
      ,(car args)
      " ] "
      "\\!"
      " ] "
      " \\, "
      ,(cadr args)
      " \\, "
      ,(caddr args)
      )))
    

(make-presentation-format *tex-form* 'sexp%cons '() tex-present-sexp 80)
(make-presentation-format *tex-form* 'eval " { \\cal E} " tex-present-eval 80) 
