;% Copyright (c) 1990-1994 The MITRE Corporation
;% 
;% Authors: W. M. Farmer, J. D. Guttman, F. J. Thayer
;%   
;% The MITRE Corporation (MITRE) provides this software to you without
;% charge to use, copy, modify or enhance for any legitimate purpose
;% provided you reproduce MITRE's copyright notice in any copy or
;% derivative work of this software.
;% 
;% This software is the copyright work of MITRE.  No ownership or other
;% proprietary interest in this software is granted you other than what
;% is granted in this license.
;% 
;% Any modification or enhancement of this software must identify the
;% part of this software that was modified, by whom and when, and must
;% inherit this license including its warranty disclaimers.
;% 
;% MITRE IS PROVIDING THE PRODUCT "AS IS" AND MAKES NO WARRANTY, EXPRESS
;% OR IMPLIED, AS TO THE ACCURACY, CAPABILITY, EFFICIENCY OR FUNCTIONING
;% OF THIS SOFTWARE AND DOCUMENTATION.  IN NO EVENT WILL MITRE BE LIABLE
;% FOR ANY GENERAL, CONSEQUENTIAL, INDIRECT, INCIDENTAL, EXEMPLARY OR
;% SPECIAL DAMAGES, EVEN IF MITRE HAS BEEN ADVISED OF THE POSSIBILITY OF
;% SUCH DAMAGES.
;% 
;% You, at your expense, hereby indemnify and hold harmless MITRE, its
;% Board of Trustees, officers, agents and employees, from any and all
;% liability or damages to third parties, including attorneys' fees,
;% court costs, and other related costs and expenses, arising out of your
;% use of this software irrespective of the cause of said liability.
;% 
;% The export from the United States or the subsequent reexport of this
;% software is subject to compliance with United States export control
;% and munitions control restrictions.  You agree that in the event you
;% seek to export this software or any derivative work thereof, you
;% assume full responsibility for obtaining all necessary export licenses
;% and approvals and for assuring compliance with applicable reexport
;% restrictions.
;% 
;% 
;% COPYRIGHT NOTICE INSERTED: Mon Apr 11 11:42:27 EDT 1994


(herald test-hash)

(set *my-table* (make-table))

(set random (make-random 1234))

(define (random-fill-hash count)
  (do ((i 0 (fx+ i 1)))
      ((fx= i count))
    (let ((next-key (random))
	  (next-value (random)))
      (set (table-entry *my-table* next-key) next-value))))

(define (fill-hash count)
  (do ((i 0 (fx+ i 1)))
      ((fx= i count))
    (let ((next-key i)
	  (next-value i))
      (set (table-entry *my-table* next-key) next-value))))

(define (test-random count)
  (do ((i 0 (fx+ i 1)))
      ((fx= i count))
    (let ((next-key (random))
	  (next-value (random)))
      (or next-key next-value))))
    

(define (count-hash-size)
  (let ((counter 0))
    (walk-table
     (lambda (key value)
       (ignore key value)
       (set counter (fx+ counter 1)))
     *my-table*)
    counter))

(define (walk-hash)
  (walk-table
     (lambda (key value)
       (and key value))
     *my-table*))

(define (print-hash file-name)
  (with-open-streams ((s (open file-name '(out))))
    (walk-table
     (lambda (key value)
       (format s "~%~S  ~S~&" key value))
     *my-table*)))

(define (scribble-hash)
  (walk-table
     (lambda (key value)
       (format nil "~%~S  ~S~&" key value))
     *my-table*))

(define (read-hash file-name)
  (with-open-streams
   ((s (open file-name '(in))))
   (let ((table (make-table)))
     (iterate loop ((key (read s))
		    (value (read s)))
       (cond ((or (eof? key)
		  (eof? value))
	      table)
	     (else
	      (set (table-entry table key) value)
	      (loop (read s)(read s))))))))



