;% Copyright (c) 1990-1994 The MITRE Corporation
;% 
;% Authors: W. M. Farmer, J. D. Guttman, F. J. Thayer
;%   
;% The MITRE Corporation (MITRE) provides this software to you without
;% charge to use, copy, modify or enhance for any legitimate purpose
;% provided you reproduce MITRE's copyright notice in any copy or
;% derivative work of this software.
;% 
;% This software is the copyright work of MITRE.  No ownership or other
;% proprietary interest in this software is granted you other than what
;% is granted in this license.
;% 
;% Any modification or enhancement of this software must identify the
;% part of this software that was modified, by whom and when, and must
;% inherit this license including its warranty disclaimers.
;% 
;% MITRE IS PROVIDING THE PRODUCT "AS IS" AND MAKES NO WARRANTY, EXPRESS
;% OR IMPLIED, AS TO THE ACCURACY, CAPABILITY, EFFICIENCY OR FUNCTIONING
;% OF THIS SOFTWARE AND DOCUMENTATION.  IN NO EVENT WILL MITRE BE LIABLE
;% FOR ANY GENERAL, CONSEQUENTIAL, INDIRECT, INCIDENTAL, EXEMPLARY OR
;% SPECIAL DAMAGES, EVEN IF MITRE HAS BEEN ADVISED OF THE POSSIBILITY OF
;% SUCH DAMAGES.
;% 
;% You, at your expense, hereby indemnify and hold harmless MITRE, its
;% Board of Trustees, officers, agents and employees, from any and all
;% liability or damages to third parties, including attorneys' fees,
;% court costs, and other related costs and expenses, arising out of your
;% use of this software irrespective of the cause of said liability.
;% 
;% The export from the United States or the subsequent reexport of this
;% software is subject to compliance with United States export control
;% and munitions control restrictions.  You agree that in the event you
;% seek to export this software or any derivative work thereof, you
;% assume full responsibility for obtaining all necessary export licenses
;% and approvals and for assuring compliance with applicable reexport
;% restrictions.
;% 
;% 
;% COPYRIGHT NOTICE INSERTED: Mon Apr 11 11:42:27 EDT 1994


(herald unique-ratios (env tsys))

(lset %%unique-rational-table (make-table '%%unique-rational-table))

(define (ratio p q)
  (let ((p (enforce integer? p))
        (q (enforce integer? q))
        (normal (lambda (p q)
                  (let ((g (gcd p q)))
                    (let ((p (quotient p g))
                          (q (quotient q g)))
                      (cond ((= q 1) p)
			    ((two-d-table-entry %%unique-rational-table p q))
			    (else
			     (let ((rat
				    (object nil
				      ((extended-number-type self)
				       %%ratio-number-type)
				      ((ratio? self) t)
				      ((numerator self) p)
				      ((denominator self) q)
				      ((print self port)
				       (format port "~s~c~s"
					       p ratio-char q)))))
			       (set (two-d-table-entry %%unique-rational-table p q) rat)
			       rat))))))))
    ;; ... put p & q in lowest terms ...
    (cond ((= q 0) (error "attempt to divide by zero~%  (/ ~s ~s)" p q))
          ((< q 0) (normal (- 0 p) (- 0 q)))
          (else (normal p q)))))

