;% Copyright (c) 1990-1994 The MITRE Corporation
;% 
;% Authors: W. M. Farmer, J. D. Guttman, F. J. Thayer
;%   
;% The MITRE Corporation (MITRE) provides this software to you without
;% charge to use, copy, modify or enhance for any legitimate purpose
;% provided you reproduce MITRE's copyright notice in any copy or
;% derivative work of this software.
;% 
;% This software is the copyright work of MITRE.  No ownership or other
;% proprietary interest in this software is granted you other than what
;% is granted in this license.
;% 
;% Any modification or enhancement of this software must identify the
;% part of this software that was modified, by whom and when, and must
;% inherit this license including its warranty disclaimers.
;% 
;% MITRE IS PROVIDING THE PRODUCT "AS IS" AND MAKES NO WARRANTY, EXPRESS
;% OR IMPLIED, AS TO THE ACCURACY, CAPABILITY, EFFICIENCY OR FUNCTIONING
;% OF THIS SOFTWARE AND DOCUMENTATION.  IN NO EVENT WILL MITRE BE LIABLE
;% FOR ANY GENERAL, CONSEQUENTIAL, INDIRECT, INCIDENTAL, EXEMPLARY OR
;% SPECIAL DAMAGES, EVEN IF MITRE HAS BEEN ADVISED OF THE POSSIBILITY OF
;% SUCH DAMAGES.
;% 
;% You, at your expense, hereby indemnify and hold harmless MITRE, its
;% Board of Trustees, officers, agents and employees, from any and all
;% liability or damages to third parties, including attorneys' fees,
;% court costs, and other related costs and expenses, arising out of your
;% use of this software irrespective of the cause of said liability.
;% 
;% The export from the United States or the subsequent reexport of this
;% software is subject to compliance with United States export control
;% and munitions control restrictions.  You agree that in the event you
;% seek to export this software or any derivative work thereof, you
;% assume full responsibility for obtaining all necessary export licenses
;% and approvals and for assuring compliance with applicable reexport
;% restrictions.
;% 
;% 
;% COPYRIGHT NOTICE INSERTED: Mon Apr 11 11:42:27 EDT 1994


(herald THEORY-CONTEXTS)


;(define (THEORY-CONTEXT-SIMPLIFY-NON-FORMULA context expr persist)
;  (simplify-with-partially-simplified-form
;   context
;   expr
;   (lambda (context expr)
;     (if (transform-handler?
;	  (theory-transform-handler (context-theory context)))
;	 (receive (simplified reqs)
;	   (simplify-term (theory-transform-handler (context-theory context))
;			  expr context persist)
;	   (cond ((necessarily-undefined? simplified)
;		  (undefined (expression-sorting expr)))
;		 ((tc-refute-requirements context reqs persist)
;		  (cond ((formula? expr) falsehood)
;			((predicate? expr) (lambda-wrap falsehood (domain-sorts expr)))
;			((predicator? expr) expr)
;			((term-or-fn? expr) (undefined (expression-sorting expr)))
;			(else (imps-error "THEORY-CONTEXT-SIMPLIFY-NON-FORMULA: unkind expression ~S.~&Please inform Josh." expr))))
;		 ((and (not (eq? simplified expr))
;		       (tc-prove-requirements context reqs persist))
;		  simplified)
;		 (else expr)))
;	 expr))))
;
;;An atomic-formula could very well be a prop valued lambda application.
;;The way to handle these is NOT by giving it to the transform handler
;;but to beta reduce it (keeping note of  requirements) first and then apply
;;context-simplify
;
;(define (THEORY-CONTEXT-SIMPLIFY-ATOMIC-FORMULA context expr persist)
;  (simplify-with-partially-simplified-form
;   context
;   expr
;   (lambda (context expr)
;     (if (transform-handler?
;	  (theory-transform-handler (context-theory context)))
;	 (receive (simplified reqs)
;	
;	   (if (lambda-application? expr)
;	    
;	       ;;if expr is a formula and a lambda-application beta-reduce and simplify
;	       ;;the formula
;	
;	       (return (context-simplify context (beta-reduce expr) persist)
;		       (substitution-definedness-conditions
;			(map
;			 cons
;			 (binding-variables (operator expr))
;			 (arguments expr))))
;    
;	       ;; otherwise call simplify-"term"
;	    
;	       (simplify-term (theory-transform-handler (context-theory context))
;			      expr context persist))
;
;	   (cond ((necessarily-false? simplified)
;		  falsehood)
;		 ((tc-refute-requirements context reqs persist)
;		  falsehood)
;		 ((and (not (eq? simplified expr))		
;		       (tc-prove-requirements context reqs persist))
;		  simplified)
;		 ((truth? simplified) (apply conjunction reqs))
;		 (else expr)))
;	 expr))))
;
;(define (tc-prove-requirements context reqs persist)	   
;  (every?
;   (lambda (req)
;     (let ((simplified-req
;	    (context-simplify context req (-1+ persist))))
;       (cond ((truth? simplified-req))
;	     ((accumulate-undischarged-minor-premises?)
;	      (push undischarged-minor-premises
;		    (build-sequent context simplified-req))
;	      '#t)
;	     (else '#f))))
;   reqs))
;
;(define (tc-refute-requirements context reqs persist)
;  (ignore persist)
;  (any?
;   (lambda (req)
;     (if (dont-work-on-definedness)
;	 (falsehood? (recursive-constructor-simplify req))
;	 (bind (((dont-work-on-definedness) '#t))
;	   (context-immediately-entails? context (push-not req)))))
;   reqs))
;
;;;;(define theory-context-simplify-sloppily
;;;;  (make-simple-switch 'theory-context-simplify-sloppily boolean? '#f))
;	 
;(define (THEORY-CONTEXT-SIMPLIFY-EQUALITY theory-context expr persist)
;  (imps-enforce theory-context? theory-context)
;  (let ((new1 (context-term-simplify
;	       theory-context (expression-lhs expr) (-1+ persist)))
;	(new2 (context-term-simplify
;	       theory-context (expression-rhs expr) (-1+ persist)))
;	(handler (theory-transform-handler (context-theory theory-context))))
;    (receive (new-formula reqs)
;      (cond ((and handler (transform-handler-comparator handler))
;	     (transform-handler-compare handler new1 new2 theory-context persist))
;	    (else (return
;		   ((constructor-simplifier equality) (list new1 new2))
;		   nil)))
;      (if (and (not (eq? new-formula expr))		;if nothing changes why do any work?
;	       (tc-prove-requirements theory-context reqs persist))
;	  (context-simplify theory-context new-formula (-1+ persist))
;	  expr))))
;
;;;; In theory-context-entails? we assume that other context-entailment tricks
;;;; have already been tried.  Eg, we may assume that the formula is in a
;;;; simplified form.   
;
;;;; (define (theory-context-entails? theory-context formula persist)
;;;;   (let ((seq (build-sequent theory-context formula)))
;;;;     (any?
;;;;      (lambda (thm)
;;;;        (theorem-instance? thm seq persist))
;;;;      (theory-theorems (context-theory theory-context)))))
;;;;   
;
;(define (theory-context-entails? theory-context formula persist)
;  '#f)
;
;(define (theory-context-immediately-entails? theory-context formula)
;  (ignore theory-context formula)
;  '#f)
;
;(define (CONTEXT-MEETS-CONVERGENCE-REQUIREMENTS? context convergence-requirements)
;  (every?
;   (lambda (term)
;     (context-immediately-entails-defined? context term))
;   convergence-requirements))
;
;
;(define (SEQUENT->THEORY-SEQUENT theory sequent)
;  (build-sequent (context->theory-context theory (sequent-context sequent))
;		 (sequent-assertion sequent)))
;

'la
